controllers/SiteController.php
<?php

namespace app\controllers;

use Yii;
use yii\filters\AccessControl;
use yii\web\Controller;
use yii\web\Response;
use yii\filters\VerbFilter;
use app\models\LoginForm;
use app\models\ContactForm;

class SiteController extends Controller
{
    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        return [
            'access' => [
                'class' => AccessControl::class,
                'only' => ['logout'],
                'rules' => [
                    [
                        'actions' => ['logout'],
                        'allow' => true,
                        'roles' => ['@'],
                    ],
                ],
            ],
            'verbs' => [
                'class' => VerbFilter::class,
                'actions' => [
                    'logout' => ['post'],
                ],
            ],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function actions()
    {
        return [
            'error' => [
                'class' => 'yii\web\ErrorAction',
            ],
            'captcha' => [
                'class' => 'yii\captcha\CaptchaAction',
                'fixedVerifyCode' => YII_ENV_TEST ? 'testme' : null,
            ],
        ];
    }

    /**
     * Displays homepage.
     *
     * @return string
     */
    public function actionIndex()
    {
        return $this->render('index');
    }

    public function actionEjercicio1()
    {
        $alumnos = [
            'jorge',
            'pedro',
            'maria',
            'laura',
            'marcos'
        ];
        return $this->render('ejercicio1', [
            'variable' => $alumnos
        ]);
    }

    public function actionEjercicio2a()
    {
        $alumnos = [
            'foto (1).jpeg',
            'foto (2).jpeg',
            'foto (3).jpeg',
            'foto (4).jpeg'
        ];

        return $this->render('ejercicio2a', [
            'imagenes' => $alumnos
        ]);
    }

    public function actionEjercicio2b()
    {
        $alumnos = [
            'foto (1).jpeg',
            'foto (2).jpeg',
            'foto (3).jpeg',
            'foto (4).jpeg'
        ];

        return $this->render('ejercicio2b', [
            'imagenes' => $alumnos
        ]);
    }

    public function actionEjercicio3($id = 0)
    {
        $alumnos = [
            [
                "nombre" => "Jorge",
                "poblacion" => "Santander",
                "imagen" => "foto (1).jpeg"
            ],
            [
                "nombre" => "Pedro",
                "poblacion" => "Cantabria",
                "imagen" => "foto (2).jpeg"
            ],
            [
                "nombre" => "Maria",
                "poblacion" => "Cantabria",
                "imagen" => "foto (3).jpeg"
            ],
            [
                "nombre" => "Laura",
                "poblacion" => "Cantabria",
                "imagen" => "foto (4).jpeg"
            ]
        ];

        $alumnoSinFoto = $alumnos[$id];
        // quito la imagen en el array alumnoSinFoto para el widget
        unset($alumnoSinFoto["imagen"]);

        return $this->render('ejercicio3', [
            "alumno" => $alumnos[$id],
            "alumnoSinFoto" => $alumnoSinFoto
        ]);
    }


    public function actionEjercicio4()
    {
        $numeros = [
            1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20
        ];
        return $this->render('ejercicio4', [
            'numeros' => $numeros
        ]);
    }

    public function actionEjercicio5()
    {
        $datos = [
            [
                "id" => 1,
                "nombre" => "Jorge",
                "poblacion" => "Santander",
                "direccion" => "calle de abajo"
            ],
            [
                "id" => 2,
                "nombre" => "Pedro",
                "poblacion" => "Cantabria",
                "direccion" => "calle de arriba"
            ],
            [
                "id" => 3,
                "nombre" => "Maria",
                "poblacion" => "Cantabria",
                "direccion" => "calle de arriba"
            ],
            [
                "id" => 4,
                "nombre" => "Laura",
                "poblacion" => "Cantabria",
                "direccion" => "calle de arriba"
            ]
        ];

        // quiero que en la vista se muestren los datos anteriores
        // utilizando CARDS
        // en el titulo de la CARD me coloca el id de cada elemento
        // en el texto de la CARD me coloca el nombre
        // el resto de los campos en una lista dentro de la CARD
        // con el formato NombreCampo: valor

        return $this->render('ejercicio5', [

            'datos' => $datos
        ]);
    }

    public function actionEjercicio6()
    {
        $datos = [
            [
                "id" => 1,
                "nombre" => "Jorge",
                "poblacion" => "Santander",
                "direccion" => "calle de abajo"
            ],
            [
                "id" => 2,
                "nombre" => "Pedro",
                "poblacion" => "Cantabria",
                "direccion" => "calle de arriba"
            ],
            [
                "id" => 3,
                "nombre" => "Maria",
                "poblacion" => "Cantabria",
                "direccion" => "calle de arriba"
            ],
            [
                "id" => 4,
                "nombre" => "Laura",
                "poblacion" => "Cantabria",
                "direccion" => "calle de arriba"
            ]
        ];

        // quiero que en la vista se muestren los datos anteriores
        // utilizando CARDS
        // en el titulo de la CARD me coloca el id de cada elemento
        // en el texto de la CARD me coloca el nombre
        // el resto de los campos en una lista dentro de la CARD
        // con el formato NombreCampo: valor
        // utilizar subvistas (realizar render dentro de la vista)

        return $this->render('ejercicio6', [
            'datos' => $datos
        ]);
    }

}

views/layouts/main.php
<?php

/** @var yii\web\View $this */
/** @var string $content */

use app\assets\AppAsset;
use app\widgets\Alert;
use yii\bootstrap5\Breadcrumbs;
use yii\bootstrap5\Html;
use yii\bootstrap5\Nav;
use yii\bootstrap5\NavBar;

AppAsset::register($this);

$this->registerCsrfMetaTags();
$this->registerMetaTag(['charset' => Yii::$app->charset], 'charset');
$this->registerMetaTag(['name' => 'viewport', 'content' => 'width=device-width, initial-scale=1, shrink-to-fit=no']);
$this->registerMetaTag(['name' => 'description', 'content' => $this->params['meta_description'] ?? '']);
$this->registerMetaTag(['name' => 'keywords', 'content' => $this->params['meta_keywords'] ?? '']);
$this->registerLinkTag(['rel' => 'icon', 'type' => 'image/x-icon', 'href' => Yii::getAlias('@web/favicon.ico')]);
?>
<?php $this->beginPage() ?>
<!DOCTYPE html>
<html lang="<?= Yii::$app->language ?>" class="h-100">

<head>
    <title><?= Html::encode($this->title) ?></title>
    <?php $this->head() ?>
</head>

<body class="d-flex flex-column h-100">
    <?php $this->beginBody() ?>

    <header id="header">
        <?php
        NavBar::begin([
            'brandLabel' => Yii::$app->name,
            'brandUrl' => Yii::$app->homeUrl,
            'options' => ['class' => 'navbar-expand-md navbar-dark bg-dark fixed-top']
        ]);
        echo Nav::widget([
            'options' => ['class' => 'navbar-nav'],
            'items' => [
                ['label' => 'Home', 'url' => ['/site/index']],
                ['label' => 'Ejercicio 1', 'url' => ['/site/ejercicio1']],
                ['label' => 'Ejercicio 2', 'items' => [
                    ['label' => 'Ejercicio 2 - Foreach', 'url' => ['/site/ejercicio2a']],
                    ['label' => 'Ejercicio 2 - Ul', 'url' => ['/site/ejercicio2b']],
                ]],
                ['label' => 'Ejercicio 3', 'items' => [
                    ['label' => 'Ejercicio 3 - Alumno 1', 'url' => ['/site/ejercicio3', 'id' => 0]],
                    ['label' => 'Ejercicio 3 - Alumno 2', 'url' => ['/site/ejercicio3', 'id' => 1]],
                    ['label' => 'Ejercicio 3 - Alumno 3', 'url' => ['/site/ejercicio3', 'id' => 2]],
                    ['label' => 'Ejercicio 3 - Alumno 4', 'url' => ['/site/ejercicio3', 'id' => 3]],
                ]],
                ['label' => 'Ejercicio 4', 'url' => ['/site/ejercicio4']],
                ['label' => 'Ejercicio 5', 'url' => ['/site/ejercicio5']],
                ['label' => 'Ejercicio 6', 'url' => ['/site/ejercicio6']],
            ]
        ]);
        NavBar::end();
        ?>
    </header>

    <main id="main" class="flex-shrink-0" role="main">
        <div class="container">
            <?php if (!empty($this->params['breadcrumbs'])) : ?>
                <?= Breadcrumbs::widget(['links' => $this->params['breadcrumbs']]) ?>
            <?php endif ?>
            <?= Alert::widget() ?>
            <?= $content ?>
        </div>
    </main>

    <footer id="footer" class="mt-auto py-3 bg-light">
        <div class="container">
            <div class="row text-muted">
                <div class="col-md-6 text-center text-md-start">&copy; My Company <?= date('Y') ?></div>
                <div class="col-md-6 text-center text-md-end"><?= Yii::powered() ?></div>
            </div>
        </div>
    </footer>

    <?php $this->endBody() ?>
</body>

</html>
<?php $this->endPage() ?>

views/site/_ejercicio6Item.php
<div class="col-sm-3">
      <div class="card">
          <div class="card-header">
              <h3 class="card-title">Id: <?= $dato["id"] ?></h3>
          </div>
          <div class="card-body">
              <p class="card-text">Nombre: <?= $dato["nombre"] ?></p>
          </div>
          <ul class=" list-group list-group-flush">
              <li class="list-group-item">Poblacion: <?= $dato["poblacion"] ?></li>
              <li class="list-group-item">Direccion: <?= $dato["direccion"] ?></li>
          </ul>
      </div>
  </div>

views/site/_elemento.php
<li class="list-group-item"><?= $numero?></li>

views/site/_listado.php
<ul class="list-group list-group-horizontal">
    <?php
    foreach ($numeros as $numero) {
        echo $this->render('_elemento', [
            'numero' => $numero
        ]);
    }
    ?>
</ul>

views/site/ejercicio1.php
<ul>
    <?php

    foreach ($variable as $alumno) {
        echo "<li>$alumno</li>";
    }
    ?>

</ul>

views/site/ejercicio2a.php
<?php

use yii\helpers\Html;


// realizarlo con foreach
echo "<ul class='list-group list-group-horizontal'>";
foreach ($imagenes as $foto) {
    echo "<li class='list-group-item col-lg-3'>";
    echo Html::img("@web/imgs/{$foto}", [
        'class' => 'img-thumbnail',
    ]);
    echo "</li>";
}
echo "</ul>";

views/site/ejercicio2b.php
<?php

use yii\helpers\Html;


echo Html::ul($imagenes, [
    'class' => 'list-group list-group-horizontal',  // colocar una clase a la etiqueta ul
    'item' => function ($foto, $indice) {
        $salida = "<li class='list-group-item col-lg-3'>";
        $salida .= Html::img("@web/imgs/{$foto}", [
            'class' => 'img-thumbnail',
        ]);
        $salida .= "</li>";
        return $salida;
    },
]);

views/site/ejercicio3.php
<?php

// sin utilizar Helpers de HTML

use yii\helpers\Html;

?>

<div class="row">
    <div class="col-sm-3">
        <div class="card">
            <img src="<?= Yii::getAlias("@web") ?>/imgs/<?= $alumno["imagen"] ?>">
            <div class="card-body">
                <p>Nombre: <?= $alumno["nombre"] ?></p>
                <p>Poblacion: <?= $alumno["poblacion"] ?></p>

            </div>
        </div>
    </div>
    <div class="col-sm-3">
        <div class="card">
            <img src="<?= Yii::getAlias("@web") ?>/imgs/<?= $alumno["imagen"] ?>">
            <ul class="list-group list-group-flush">
                <li class="list-group-item">Nombre: <?= $alumno["nombre"] ?></li>
                <li class="list-group-item">Poblacion: <?= $alumno["poblacion"] ?></li>
            </ul>

        </div>
    </div>
</div>

<?php

// quiero utilizar los helpers de HTML

?>
<div class="row">
    <div class="col-sm-3">
        <div class="card">
            <?= Html::img("@web/imgs/{$alumno["imagen"]}") ?>
            <?= Html::ul($alumnoSinFoto, [
                "class" => "list-group list-group-flush",
                "itemOptions" => [
                    "class" => "list-group-item"
                ],
                // "item" => function ($dato, $indice) {
                //     $salida = "";
                //     if ($indice != "imagen") {
                //         $salida .= "<li class='list-group-item'>{$indice}: {$dato}</li>";
                //     }
                //     return $salida;
                // }
            ]) ?>
        </div>
    </div>
</div>

views/site/ejercicio4.php
<?php

echo $this->render('_listado', [
    'numeros' => $numeros
]);

// sin crear vistas nuevas
?>
<br><br>
<ul class="list-group list-group-horizontal">
    <?php
    foreach ($numeros as $numero) {
        echo '<li class="list-group-item">' . $numero . '</li>';
    }
    ?>
</ul>
<br>
<br>
<?php

// con el helper Html::ul

use yii\helpers\Html;

echo Html::ul($numeros, [
    'class' => 'list-group list-group-horizontal',
    'itemOptions' => [
        'class' => 'list-group-item'
    ]
]);

views/site/ejercicio5.php
<?php

// sin utilizar Helpers de HTML

use yii\helpers\Html;

?>

<div class="row">
    <?php
    foreach ($datos as $dato) {
    ?>
        <div class="col-sm-3">
            <div class="card">
                <div class="card-header">
                    <h3 class="card-title">Id: <?= $dato["id"] ?></h3>
                </div>
                <div class="card-body">
                    <p class="card-text">Nombre: <?= $dato["nombre"] ?></p>
                </div>
                <ul class=" list-group list-group-flush">
                    <li class="list-group-item">Poblacion: <?= $dato["poblacion"] ?></li>
                    <li class="list-group-item">Direccion: <?= $dato["direccion"] ?></li>
                </ul>
            </div>
        </div>
    <?php
    }
    ?>
</div>

views/site/ejercicio6.php
<?php

// sin utilizar Helpers de HTML

use yii\helpers\Html;

// echo "<div class='row'>";
echo Html::beginTag('div', ['class' => 'row']);
foreach ($datos as $dato) {
    echo $this->render("_ejercicio6Item", ['dato' => $dato]);
}

echo Html::endTag('div');
// echo "</div>";

views/site/error.php
<?php

/** @var yii\web\View $this */
/** @var string $name */
/** @var string $message */
/** @var Exception$exception */

use yii\helpers\Html;

$this->title = $name;
?>
<div class="site-error">

    <h1><?= Html::encode($this->title) ?></h1>

    <div class="alert alert-danger">
        <?= nl2br(Html::encode($message)) ?>
    </div>

    <p>
        The above error occurred while the Web server was processing your request.
    </p>
    <p>
        Please contact us if you think this is a server error. Thank you.
    </p>

</div>

views/site/index.php
<?php

/** @var yii\web\View $this */

$this->title = 'Pagina de inicio';
?>
<div class="site-index">
    <div class="body-content">

        <div class="row">
            <div class="col-12">
                <h2>Ejemplo 2</h2>

                <p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et
                    dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip
                    ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu
                    fugiat nulla pariatur.</p>
            </div>
        </div>

    </div>
</div>